The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
RtMidiOut Class Reference

A realtime MIDI output class. More...

`#include <RtMidi.h>`

Inheritance diagram for RtMidiOut:

## Public Member Functions
| RtMidiOut (RtMidi::Api api=UNSPECIFIED, const std::string &clientName="RtMidi Output Client")
| Default constructor that allows an optional client name.
| ~RtMidiOut (void) throw ()
| The destructor closes any open MIDI connections.
RtMidi::Api | getCurrentApi (void) throw ()
| Returns the MIDI API specifier for the current instance of RtMidiOut.
void | openPort (unsigned int portNumber=0, const std::string &portName=std::string("RtMidi Output"))
| Open a MIDI output connection.
void | closePort (void)
| Close an open MIDI connection (if one exists).
virtual bool | isPortOpen () const
| Returns true if a port is open and false if not.
void | openVirtualPort (const std::string &portName=std::string("RtMidi Output"))
| Create a virtual output port, with optional name, to allow software connections (OS X, JACK and ALSA only).
unsigned int | getPortCount (void)
| Return the number of available MIDI output ports.
std::string | getPortName (unsigned int portNumber=0)
| Return a string identifier for the specified MIDI port type and number.
void | sendMessage (const std::vector< unsigned char > *message)
| Immediately send a single message out an open MIDI output port.
void | sendMessage (const unsigned char *message, size_t size)
| Immediately send a single message out an open MIDI output port.
virtual void | setErrorCallback (RtMidiErrorCallback errorCallback=NULL, void *userData=0)
| Set an error callback function to be invoked when an error has occurred.
virtual void | openPort (unsigned int portNumber=0, const std::string &portName=std::string("RtMidi"))=0
| Pure virtual openPort() function.
virtual void | openVirtualPort (const std::string &portName=std::string("RtMidi"))=0
| Pure virtual openVirtualPort() function.
virtual unsigned int | getPortCount ()=0
| Pure virtual getPortCount() function.
virtual std::string | getPortName (unsigned int portNumber=0)=0
| Pure virtual getPortName() function.
virtual void | closePort (void)=0
| Pure virtual closePort() function.
virtual bool | isPortOpen (void) const =0
| Returns true if a port is open and false if not.
virtual void | setErrorCallback (RtMidiErrorCallback errorCallback=NULL, void *userData=0)=0
| Set an error callback function to be invoked when an error has occurred.

## Additional Inherited Members
Public Types inherited from RtMidi
enum | Api { UNSPECIFIED , MACOSX_CORE , LINUX_ALSA , UNIX_JACK , WINDOWS_MM , RTMIDI_DUMMY , WEB_MIDI_API , WINDOWS_UWP , ANDROID_AMIDI , NUM_APIS }
| MIDI API specifier arguments. More...
Static Public Member Functions inherited from RtMidi
static std::string | getVersion (void) throw ()
| A static function to determine the current RtMidi version.
static void | getCompiledApi (std::vector< RtMidi::Api > &apis) throw ()
| A static function to determine the available compiled MIDI APIs.
static std::string | getApiName (RtMidi::Api api)
| Return the name of a specified compiled MIDI API.
static std::string | getApiDisplayName (RtMidi::Api api)
| Return the display name of a specified compiled MIDI API.
static RtMidi::Api | getCompiledApiByName (const std::string &name)
| Return the compiled MIDI API having the given name.

## Detailed Description

A realtime MIDI output class.

This class provides a common, platform-independent API for MIDI output. It allows one to probe available MIDI output ports, to connect to one such port, and to send MIDI bytes immediately over the connection. Create multiple instances of this class to connect to more than one MIDI device at the same time. With the OS-X, Linux ALSA and JACK MIDI APIs, it is also possible to open a virtual port to which other MIDI software clients can connect.

## Constructor & Destructor Documentation

## ◆ RtMidiOut()

RtMidiOut::RtMidiOut | ( | RtMidi::Api | api = `UNSPECIFIED`,
|  | const std::string & | clientName = `"RtMidi Output Client"`
| ) |  |

Default constructor that allows an optional client name.

An exception will be thrown if a MIDI system initialization error occurs.

If no API argument is specified and multiple API support has been compiled, the default order of use is ALSA, JACK (Linux) and CORE, JACK (OS-X).

## Member Function Documentation

## ◆ openPort()

void RtMidiOut::openPort | ( | unsigned int | portNumber = `0`,
|  | const std::string & | portName = `std::string( "RtMidi Output" )`
| ) |  |
| inlinevirtual

Open a MIDI output connection.

An optional port number greater than 0 can be specified. Otherwise, the default or first port found is opened. An exception is thrown if an error occurs while attempting to make the port connection.

Implements RtMidi.

667{ rtapi_->openPort( portNumber, portName ); }

## ◆ isPortOpen()

bool RtMidiOut::isPortOpen | ( | void |  | ) | const
| inlinevirtual

Returns true if a port is open and false if not.

Note that this only applies to connections made with the openPort() function, not to virtual ports.

Implements RtMidi.

670{ return rtapi_->isPortOpen(); }

## ◆ openVirtualPort()

void RtMidiOut::openVirtualPort | ( | const std::string & | portName = `std::string( "RtMidi Output" )` | ) |
| inlinevirtual

Create a virtual output port, with optional name, to allow software connections (OS X, JACK and ALSA only).

This function creates a virtual MIDI output port to which other software applications can connect. This type of functionality is currently only supported by the Macintosh OS-X, Linux ALSA and JACK APIs (the function does nothing with the other APIs). An exception is thrown if an error occurs while attempting to create the virtual port.

Implements RtMidi.

668{ rtapi_->openVirtualPort( portName ); }

## ◆ getPortName()

std::string RtMidiOut::getPortName | ( | unsigned int | portNumber = `0` | ) |
| inlinevirtual

Return a string identifier for the specified MIDI port type and number.

Returns
  The name of the port with the given Id is returned.

Return values

  An | empty string is returned if an invalid port specifier is provided. User code should assume a UTF-8 encoding.

Implements RtMidi.

672{ return rtapi_->getPortName( portNumber ); }

## ◆ sendMessage() [1/2]

void RtMidiOut::sendMessage | ( | const std::vector< unsigned char > * | message | ) |
| inline

Immediately send a single message out an open MIDI output port.

An exception is thrown if an error occurs during output or an output connection was not previously established.

673{ static_cast<MidiOutApi *>(rtapi_)->sendMessage( &message->at(0), message->size() ); }
RtMidiOut::sendMessage
void sendMessage(const std::vector< unsigned char > *message)
Immediately send a single message out an open MIDI output port.
Definition RtMidi.h:673

## ◆ sendMessage() [2/2]

void RtMidiOut::sendMessage | ( | const unsigned char * | message,
|  | size_t | size
| ) |  |
| inline

Immediately send a single message out an open MIDI output port.

An exception is thrown if an error occurs during output or an output connection was not previously established.

Parameters

  message | A pointer to the MIDI message as raw bytes
  size | Length of the MIDI message in bytes

674{ static_cast<MidiOutApi *>(rtapi_)->sendMessage( message, size ); }

## ◆ setErrorCallback()

void RtMidiOut::setErrorCallback | ( | RtMidiErrorCallback | errorCallback = `NULL`,
|  | void * | userData = `0`
| ) |  |
| inlinevirtual

Set an error callback function to be invoked when an error has occurred.

The callback function will be called whenever an error has occurred. It is best to set the error callback function before opening a port.

Implements RtMidi.

675{ rtapi_->setErrorCallback(errorCallback, userData); }

The documentation for this class was generated from the following file:

- RtMidi.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.